\Snow.xpl
\Translation of Polaris's Snow.cpp program

include c:\cxpl\codesi;

\Data structures for snow flakes = very simple
def	Total_flakes=900;
def	Total_layers=3;

int	FlakesX(Total_flakes),
	FlakesY(Total_flakes),
	FlakesLayer(Total_flakes);


proc	Initalize_particle_flakes;	\Initalize the particle flakes
int	I;
begin
for I:= 0, Total_flakes-1 do
	begin
	FlakesX(I):= Ran(320);		\0-319 (x)
	FlakesY(I):= Ran(200);		\0-199 (y)
	FlakesLayer(I):= Ran(Total_layers); \(0-2) (layer)
	end;
end;


proc	Draw_particle_flakes;		\Draw all the particle flakes
int	I;
begin
for I:= 0, Total_flakes-1 do
	begin
	Point(FlakesX(I), FlakesY(I), FlakesLayer(I)*4+23);	\bright flakes
	\Note - we are drawing according to the default color palette
	end;
end;


proc	Update_particle_flakes;		\Update the particle flakes
int	I;
begin
for I:= 0, Total_flakes-1 do
	begin
	\Drop the particle down - depending on layer.
	\Add one since layer zero would result in no motion
	FlakesY(I):= FlakesY(I) + FlakesLayer(I) + 1;

	\Check for wrap around
	if FlakesY(I) > 199 then
		begin
		FlakesX(I):= Ran(320);
		FlakesY(I):= 0;
		FlakesLayer(I):= Ran(Total_layers);
		end;

	\New X position
	FlakesX(I):= Rem((FlakesX(I)+2-Ran(5)) / 320);
	end;
end;


proc	VSync;			\Wait for vertical retrace to begin
begin
while PIn($3DA,0) & $08 do [];	\wait for vertical retrace signal to go away
repeat until PIn($3DA,0) & $08;	\wait for vertical retrace
end;	\VSync


begin	\Main
SetVid($13);			\set graphics display for 320x200x8-bit color
Initalize_particle_flakes;
while not ChkKey do
	begin
	Update_particle_flakes;
	VSync;			\slow flakes
	VSync;
	VSync;
	VSync;
	Clear;
	Draw_particle_flakes;
	end;
SetVid($03);			\restore normal text mode (for DOS)
end;
