\Torus1.xpl	25-Jan-2007	Boreal
\Rotating 3D Wireframe Torus (donut)

include	c:\cxpl\codesi;		\intrinsic code definitions

def	C1=130, C2=80;	\determine speed of rotation (larger values are slower)
def	TorR1 = 10000.0,\distance from the center of the hole in the middle
			\ to the center of the eatable tube-shaped part
	TorR2 = 6000.0;	\the distance from the center of the eatable tube-
			\ shaped part to the frosting on top
def	Sectors = 13,	\number of slices of the torus (tubes)
	Sections = 13;	\number of slices of a sector (patches)
int	TorX(Sectors+1,Sections+1),	\coordinates of vertexes approximating
	TorY(Sectors+1,Sections+1),	\ a torus
	TorZ(Sectors+1,Sections+1);


proc	VSync;			\Wait for vertical retrace to begin
begin
while PIn($3DA,0) & $08 do [];	\wait for vertical retrace signal to go away
repeat until PIn($3DA,0) & $08;	\wait for vertical retrace
end;	\VSync


proc	Rotate;			\Rotate the torus
int	I, J;
begin
for I:= 0, Sectors do
    for J:= 0, Sections do
	begin
	TorX(I,J):= TorX(I,J) + TorY(I,J)/C1;
	TorY(I,J):= TorY(I,J) - TorX(I,J)/C1;
	TorY(I,J):= TorY(I,J) + TorZ(I,J)/C2;
	TorZ(I,J):= TorZ(I,J) - TorY(I,J)/C2;
	end;
end;	\Rotate


proc	Draw;			\Draw the torus
int	I, J;
def	CX=640/2, CY=480/2,	\coordinates of center of screen
	Scale=80,		\de-magnification factor
	Color=3;		\cyan
begin
for J:= 0, Sections-1 do
	begin
	Move(TorX(0,J)/Scale+CX, TorY(0,J)/Scale+CY);
	for I:= 1, Sectors do
		Line(TorX(I,J)/Scale+CX, TorY(I,J)/Scale+CY, Color);
	end;
for I:= 0, Sectors-1 do
	begin
	Move(TorX(I,0)/Scale+CX, TorY(I,0)/Scale+CY);
	for J:= 1, Sections do
		Line(TorX(I,J)/Scale+CX, TorY(I,J)/Scale+CY, Color);
	end;
end;	\Draw


proc	SetUp;
\Find the coordinates of the vertexes of facets that approximate a torus.
\Chop the surface of the torus up into facets (polygons). To simplify later
\ calculations, the last coordinates duplicate the first coordinates. The
\ torus is initially in the X,Y plane (like a donut floating in hot grease).
\Outputs: TorX, TorY, TorZ.
int	I, J;
real	A,		\angular increments about the hole in the center
	B,		\angular increments about the center of the tube
	SA, CA, SB, CB;	\sines and cosines of A and B
def	Pi2 = 2.0 * 3.14159265358979323846;
begin
for I:= 0, Sectors do
	begin
	A:= Float(I) / Float(Sectors) * Pi2;
	SA:= Sin(A);   CA:= Cos(A);
	for J:= 0, Sections do
		begin
		B:= Float(J) / Float(Sections) * Pi2;
		SB:= Sin(B);   CB:= Cos(B);
		TorX(I,J):= Fix((TorR1 + TorR2*CB) * CA);
		TorY(I,J):= Fix((TorR1 + TorR2*CB) * SA);
		TorZ(I,J):= Fix(TorR2 * SB);
		end;
	end;
end;	\SetUp


begin	\Main
SetVid($12);			\640x480x16 graphics
SetUp;
loop	begin
	Clear;			\erase screen
	Draw;			\draw the torus
	Rotate;			\rotate the torus for the next frame
	if ChkKey then quit;	\terminate program if any keystroke
	VSync;			\wait for vertical blank
	VSync;			\wait again to provide a 30th second delay
	end;
OpenI(0);			\eat the keystroke
SetVid(3);			\restore normal text mode
end;	\Main
