\XFade.xpl
\Based on Polaris's CrossFade example in Hugi 31
\Compile with 32-bit XPL0 (xpx.bat)

include	c:\cxpl\codes;		\intrinsic 'code' declarations for 32-bit XPL0

int	CpuReg,			\array containing CPU hardware registers
	DataSeg,		\our data segment address
	I;			\index for Main
real	XFade;			\cross-fade; 0.=image1, 1.=image2
char	Image1(320*200),	\image from .bmp file
	Pal1(256*3),		\palette from the .bmp file
	Image2(320*200),
	Pal2(256*3),
	ImageCombo(320*200),	\combined images
	PalCombo(256*3);


proc	VSync;			\Wait for vertical retrace to begin
begin
while port($3DA) & $08 do [];	\wait for vertical retrace signal to go away
repeat until port($3DA) & $08;	\wait for vertical retrace
end;	\VSync


proc	LoadBmp(Name, Image, Pal);	\Load 320x200x8 .bmp file
char	Name,		\file name
	Image,		\array to store image into
	Pal;		\palette array
int	Hand, I, T,
	X, Y;		\coordinates
begin
Hand:= FOpen(Name, 0);			\open file for input
FSet(Hand, ^I);				\set device 3 to handle
OpenI(3);
for I:= 0, 53 do T:= ChIn(3);		\skip unused header info
for I:= 0, 255 do
	begin
	Pal(I*3+2):= ChIn(3)>>2;	\blue
	Pal(I*3+1):= ChIn(3)>>2;	\green
	Pal(I*3+0):= ChIn(3)>>2;	\red
	T:= ChIn(3);			\unused
	end;
for Y:= -(200-1), 0 do			\.bmp files are upside down!
    for X:= 0, 320-1 do
	Image(X-Y*320):= ChIn(3);
FClose(Hand);
end;	\LoadBmp


proc	GenPal(Degree);	\Vary PalCombo by interpolating between Pal1 and Pal2
real	Degree;		\varies from 0. to 1.
int	I, J;
begin    
\When Degree = 0. then PalCombo is at full intensity for Pal1.
\When Degree = 1. then PalCombo is at full intensity for Pal2.
for I:= 0, 256-1 do			\for all the color registers...
    for J:= 0, 3-1 do			\for red, green, blue...
	PalCombo(I*3+J):= Pal1((I>>4)*3+J) +
		fix(Degree*float( Pal2((I&$0F)*3+J) - Pal1((I>>4)*3+J) ));
end;	\GenPal


begin	\Main
CpuReg:= GetReg;			\access copy of CPU (H/W) registers
DataSeg:= CpuReg(12);			\our data segment address is in DS reg.

LoadBmp("IMAGE1.BMP", Image1, Pal1);
LoadBmp("IMAGE2.BMP", Image2, Pal2);
   	
\Create a combined bitmap from the two 16-color bitmaps
\Image1 gets the upper nibble, and Image2 gets the lower nibble
for I:= 0, 320*200-1 do
	ImageCombo(I):= Image1(I)<<4 ! (Image2(I)&$0F);

SetVid($13);					\320x200x8-bit color graphics
Blit(DataSeg, ImageCombo, $A000, 0, 320*200);	\copy bitmap to screen

XFade:= 0.0;					\start by showing Image2
repeat	XFade:= XFade + 0.005;
	GenPal(abs(1.0 - Mod(XFade, 2.0)) );
		\varies between 1 and 0, then from 0 back to 1 (sawtooth)
	VSync;					\regulate speed
	port($3C8):= 0;				\write color registers
	for I:= 0, 256*3-1 do
		port($3C9):= PalCombo(I);
until	ChkKey;

SetVid($03);					\restore normal text mode
end;	\Main
